/******************************************************************************
 * Model.cpp
 *
 * GDSAT
 *
 ******************************************************************************
 * Copyright (C) 2013 Benjamin Niedermann <niedermann@kit.edu>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/
#include <sys/wait.h>
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>
#include <limits.h>
#include <iostream>
#include "Model.h"

#define MAX PIPE_BUF*8


CNFModel::CNFModel(int var,int cnf) : temp(0){

	init(var,cnf);




}


void CNFModel::write(ostream & output){



	int count =0;
	for(int i=0; i < cnfCount; ++i){
		if(!cnfs[i].isEmpty()){
				count++;
		}
	}



	output << "p cnf "<< varCount << " " << count<<"\n";

	count =0;
	for(int i=0; i < cnfCount; ++i){
		if(!cnfs[i].isEmpty()){
	    	//cnfs[i].write(file);
	    	cnfs[i].write(output);
	    	count++;
		}

	}


}


bool CNFModel::interpret(istream & stream){

	for(int i=0; i < varCount; ++i){
		values[i] = false;
	}

	string buf;
	bool abort = true;
	while(stream >> buf){
		if(buf.compare("SAT")==0){
			abort=false;
		}else if(buf.compare("0")!=0){
			stringstream input(buf);
			int value;
			input >> value;
			if(value > 0){
				value--;
				values[value] = true;
			}
		}
		if(abort){return false;}

	}
	return true;

}

//void Model::write(FILE * file){
//
//	int count =0;
//	for(int i=0; i < cnfCount; ++i){
//		if(!cnfs[i].isEmpty()){
//				count++;
//		}
//	}
//
//
//	stringstream output;
//
//	fprintf(file, "p cnf %i %i\n",varCount,count);
//
//	output << "p cnf "<< varCount << " " << count<<"\n";
//
//	count =0;
//	for(int i=0; i < cnfCount; ++i){
//		if(!cnfs[i].isEmpty()){
//	    	cnfs[i].write(file);
//	    	count++;
//		}
//
//	}
//
//
//	string temp = output.str();
//	if(fputs(temp.c_str(),file) == EOF){
//			throw "Error while writing to pipe";
//		}
//}


CNFModel::CNFModel():nextCNF(0), temp(0) {

}

CNFModel::~CNFModel() {
}


